/*!
 * PSPDFKit for Web 2024.3.0 (https://pspdfkit.com/web)
 *
 * Copyright (c) 2016-2024 PSPDFKit GmbH. All rights reserved.
 *
 * THIS SOURCE CODE AND ANY ACCOMPANYING DOCUMENTATION ARE PROTECTED BY INTERNATIONAL COPYRIGHT LAW
 * AND MAY NOT BE RESOLD OR REDISTRIBUTED. USAGE IS BOUND TO THE PSPDFKIT LICENSE AGREEMENT.
 * UNAUTHORIZED REPRODUCTION OR DISTRIBUTION IS SUBJECT TO CIVIL AND CRIMINAL PENALTIES.
 * This notice may not be removed from this file.
 *
 * PSPDFKit uses several open source third-party components: https://pspdfkit.com/acknowledgements/web/
 */
!function(t,e){"object"==typeof exports&&"object"==typeof module?module.exports=e():"function"==typeof define&&define.amd?define([],e):"object"==typeof exports?exports.PSPDFKit=e():t.PSPDFKit=e()}(self,(()=>(()=>{"use strict";var t={r:t=>{"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})}},e={};t.r(e);const r=function t(e){let r;return r=e instanceof Error?e:new Error(e),Object.setPrototypeOf(r,t.prototype),r};r.prototype=Object.create(Error.prototype,{name:{value:"PSPDFKitError",enumerable:!1}});const n=r;function i(t,e){if(!t)throw new n(`Assertion failed: ${e||"Condition not met"}\n\nFor further assistance, please go to: https://pspdfkit.com/support/request`)}["a[href]","area[href]","input:not([disabled])","select:not([disabled])","textarea:not([disabled])","button:not([disabled])","iframe","object","embed","[contenteditable]",'[tabindex]:not([tabindex^="-"])'].join(",");function o(t){return o="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t},o(t)}function u(t){var e=function(t,e){if("object"!==o(t)||null===t)return t;var r=t[Symbol.toPrimitive];if(void 0!==r){var n=r.call(t,e||"default");if("object"!==o(n))return n;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===e?String:Number)(t)}(t,"string");return"symbol"===o(e)?e:String(e)}function s(t,e,r){return(e=u(e))in t?Object.defineProperty(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}):t[e]=r,t}new WeakMap;var a=32,c=31,f={};function h(t){t&&(t.value=!0)}function p(){}function _(t){return void 0===t.size&&(t.size=t.__iterate(v)),t.size}function l(t,e){if("number"!=typeof e){var r=e>>>0;if(""+r!==e||4294967295===r)return NaN;e=r}return e<0?_(t)+e:e}function v(){return!0}function y(t,e,r){return(0===t&&!m(t)||void 0!==r&&t<=-r)&&(void 0===e||void 0!==r&&e>=r)}function d(t,e){return w(t,e,0)}function g(t,e){return w(t,e,e)}function w(t,e,r){return void 0===t?r:m(t)?e===1/0?e:0|Math.max(0,e+t):void 0===e||e===t?t:0|Math.min(e,t)}function m(t){return t<0||0===t&&1/t==-1/0}var b="@@__IMMUTABLE_ITERABLE__@@";function S(t){return Boolean(t&&t[b])}var z="@@__IMMUTABLE_KEYED__@@";function I(t){return Boolean(t&&t[z])}var O="@@__IMMUTABLE_INDEXED__@@";function E(t){return Boolean(t&&t[O])}function j(t){return I(t)||E(t)}var M=function(t){return S(t)?t:Q(t)},D=function(t){function e(t){return I(t)?t:X(t)}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e}(M),A=function(t){function e(t){return E(t)?t:Z(t)}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e}(M),q=function(t){function e(t){return S(t)&&!j(t)?t:tt(t)}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e}(M);M.Keyed=D,M.Indexed=A,M.Set=q;var k="@@__IMMUTABLE_SEQ__@@";function x(t){return Boolean(t&&t[k])}var P="@@__IMMUTABLE_RECORD__@@";function R(t){return Boolean(t&&t[P])}function F(t){return S(t)||R(t)}var U="@@__IMMUTABLE_ORDERED__@@";function K(t){return Boolean(t&&t[U])}var B="function"==typeof Symbol&&Symbol.iterator,T="@@iterator",C=B||T,L=function(t){this.next=t};function W(t,e,r,n){var i=0===t?e:1===t?r:[e,r];return n?n.value=i:n={value:i,done:!1},n}function $(){return{value:void 0,done:!0}}function N(t){return!!V(t)}function H(t){return t&&"function"==typeof t.next}function J(t){var e=V(t);return e&&e.call(t)}function V(t){var e=t&&(B&&t[B]||t["@@iterator"]);if("function"==typeof e)return e}L.prototype.toString=function(){return"[Iterator]"},L.KEYS=0,L.VALUES=1,L.ENTRIES=2,L.prototype.inspect=L.prototype.toSource=function(){return this.toString()},L.prototype[C]=function(){return this};var G=Object.prototype.hasOwnProperty;function Y(t){return!(!Array.isArray(t)&&"string"!=typeof t)||t&&"object"==typeof t&&Number.isInteger(t.length)&&t.length>=0&&(0===t.length?1===Object.keys(t).length:t.hasOwnProperty(t.length-1))}var Q=function(t){function e(t){return null==t?ot():F(t)?t.toSeq():function(t){var e=at(t);if(e)return e;if("object"==typeof t)return new rt(t);throw new TypeError("Expected Array or collection object of values, or keyed object: "+t)}(t)}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.toSeq=function(){return this},e.prototype.toString=function(){return this.__toString("Seq {","}")},e.prototype.cacheResult=function(){return!this._cache&&this.__iterateUncached&&(this._cache=this.entrySeq().toArray(),this.size=this._cache.length),this},e.prototype.__iterate=function(t,e){var r=this._cache;if(r){for(var n=r.length,i=0;i!==n;){var o=r[e?n-++i:i++];if(!1===t(o[1],o[0],this))break}return i}return this.__iterateUncached(t,e)},e.prototype.__iterator=function(t,e){var r=this._cache;if(r){var n=r.length,i=0;return new L((function(){if(i===n)return{value:void 0,done:!0};var o=r[e?n-++i:i++];return W(t,o[0],o[1])}))}return this.__iteratorUncached(t,e)},e}(M),X=function(t){function e(t){return null==t?ot().toKeyedSeq():S(t)?I(t)?t.toSeq():t.fromEntrySeq():R(t)?t.toSeq():ut(t)}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.toKeyedSeq=function(){return this},e}(Q),Z=function(t){function e(t){return null==t?ot():S(t)?I(t)?t.entrySeq():t.toIndexedSeq():R(t)?t.toSeq().entrySeq():st(t)}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.of=function(){return e(arguments)},e.prototype.toIndexedSeq=function(){return this},e.prototype.toString=function(){return this.__toString("Seq [","]")},e}(Q),tt=function(t){function e(t){return(S(t)&&!j(t)?t:Z(t)).toSetSeq()}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.of=function(){return e(arguments)},e.prototype.toSetSeq=function(){return this},e}(Q);Q.isSeq=x,Q.Keyed=X,Q.Set=tt,Q.Indexed=Z,Q.prototype[k]=!0;var et=function(t){function e(t){this._array=t,this.size=t.length}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.get=function(t,e){return this.has(t)?this._array[l(this,t)]:e},e.prototype.__iterate=function(t,e){for(var r=this._array,n=r.length,i=0;i!==n;){var o=e?n-++i:i++;if(!1===t(r[o],o,this))break}return i},e.prototype.__iterator=function(t,e){var r=this._array,n=r.length,i=0;return new L((function(){if(i===n)return{value:void 0,done:!0};var o=e?n-++i:i++;return W(t,o,r[o])}))},e}(Z),rt=function(t){function e(t){var e=Object.keys(t);this._object=t,this._keys=e,this.size=e.length}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.get=function(t,e){return void 0===e||this.has(t)?this._object[t]:e},e.prototype.has=function(t){return G.call(this._object,t)},e.prototype.__iterate=function(t,e){for(var r=this._object,n=this._keys,i=n.length,o=0;o!==i;){var u=n[e?i-++o:o++];if(!1===t(r[u],u,this))break}return o},e.prototype.__iterator=function(t,e){var r=this._object,n=this._keys,i=n.length,o=0;return new L((function(){if(o===i)return{value:void 0,done:!0};var u=n[e?i-++o:o++];return W(t,u,r[u])}))},e}(X);rt.prototype[U]=!0;var nt,it=function(t){function e(t){this._collection=t,this.size=t.length||t.size}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.__iterateUncached=function(t,e){if(e)return this.cacheResult().__iterate(t,e);var r=J(this._collection),n=0;if(H(r))for(var i;!(i=r.next()).done&&!1!==t(i.value,n++,this););return n},e.prototype.__iteratorUncached=function(t,e){if(e)return this.cacheResult().__iterator(t,e);var r=J(this._collection);if(!H(r))return new L($);var n=0;return new L((function(){var e=r.next();return e.done?e:W(t,n++,e.value)}))},e}(Z);function ot(){return nt||(nt=new et([]))}function ut(t){var e=Array.isArray(t)?new et(t):N(t)?new it(t):void 0;if(e)return e.fromEntrySeq();if("object"==typeof t)return new rt(t);throw new TypeError("Expected Array or collection object of [k, v] entries, or keyed object: "+t)}function st(t){var e=at(t);if(e)return e;throw new TypeError("Expected Array or collection object of values: "+t)}function at(t){return Y(t)?new et(t):N(t)?new it(t):void 0}var ct="@@__IMMUTABLE_MAP__@@";function ft(t){return Boolean(t&&t[ct])}function ht(t){return ft(t)&&K(t)}function pt(t){return Boolean(t&&"function"==typeof t.equals&&"function"==typeof t.hashCode)}function _t(t,e){if(t===e||t!=t&&e!=e)return!0;if(!t||!e)return!1;if("function"==typeof t.valueOf&&"function"==typeof e.valueOf){if((t=t.valueOf())===(e=e.valueOf())||t!=t&&e!=e)return!0;if(!t||!e)return!1}return!!(pt(t)&&pt(e)&&t.equals(e))}var lt="function"==typeof Math.imul&&-2===Math.imul(4294967295,2)?Math.imul:function(t,e){var r=65535&(t|=0),n=65535&(e|=0);return r*n+((t>>>16)*n+r*(e>>>16)<<16>>>0)|0};function vt(t){return t>>>1&1073741824|3221225471&t}function yt(t){if(!1===t||null==t)return 0;if("function"==typeof t.valueOf&&(!1===(t=t.valueOf())||null==t))return 0;if(!0===t)return 1;var e=typeof t;if("number"===e){if(t!=t||t===1/0)return 0;var r=0|t;for(r!==t&&(r^=4294967295*t);t>4294967295;)r^=t/=4294967295;return vt(r)}if("string"===e)return t.length>It?function(t){var e=jt[t];void 0===e&&(e=dt(t),Et===Ot&&(Et=0,jt={}),Et++,jt[t]=e);return e}(t):dt(t);if("function"==typeof t.hashCode)return vt(t.hashCode());if("object"===e||"function"===e)return function(t){var e;if(bt&&void 0!==(e=mt.get(t)))return e;if(void 0!==(e=t[zt]))return e;if(!wt){if(void 0!==(e=t.propertyIsEnumerable&&t.propertyIsEnumerable[zt]))return e;if(void 0!==(e=function(t){if(t&&t.nodeType>0)switch(t.nodeType){case 1:return t.uniqueID;case 9:return t.documentElement&&t.documentElement.uniqueID}}(t)))return e}e=++St,1073741824&St&&(St=0);if(bt)mt.set(t,e);else{if(void 0!==gt&&!1===gt(t))throw new Error("Non-extensible objects are not allowed as keys.");if(wt)Object.defineProperty(t,zt,{enumerable:!1,configurable:!1,writable:!1,value:e});else if(void 0!==t.propertyIsEnumerable&&t.propertyIsEnumerable===t.constructor.prototype.propertyIsEnumerable)t.propertyIsEnumerable=function(){return this.constructor.prototype.propertyIsEnumerable.apply(this,arguments)},t.propertyIsEnumerable[zt]=e;else{if(void 0===t.nodeType)throw new Error("Unable to set a non-enumerable property on object.");t[zt]=e}}return e}(t);if("function"==typeof t.toString)return dt(t.toString());throw new Error("Value type "+e+" cannot be hashed.")}function dt(t){for(var e=0,r=0;r<t.length;r++)e=31*e+t.charCodeAt(r)|0;return vt(e)}var gt=Object.isExtensible,wt=function(){try{return Object.defineProperty({},"@",{}),!0}catch(t){return!1}}();var mt,bt="function"==typeof WeakMap;bt&&(mt=new WeakMap);var St=0,zt="__immutablehash__";"function"==typeof Symbol&&(zt=Symbol(zt));var It=16,Ot=255,Et=0,jt={},Mt=function(t){function e(t,e){this._iter=t,this._useKeys=e,this.size=t.size}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.get=function(t,e){return this._iter.get(t,e)},e.prototype.has=function(t){return this._iter.has(t)},e.prototype.valueSeq=function(){return this._iter.valueSeq()},e.prototype.reverse=function(){var t=this,e=Pt(this,!0);return this._useKeys||(e.valueSeq=function(){return t._iter.toSeq().reverse()}),e},e.prototype.map=function(t,e){var r=this,n=xt(this,t,e);return this._useKeys||(n.valueSeq=function(){return r._iter.toSeq().map(t,e)}),n},e.prototype.__iterate=function(t,e){var r=this;return this._iter.__iterate((function(e,n){return t(e,n,r)}),e)},e.prototype.__iterator=function(t,e){return this._iter.__iterator(t,e)},e}(X);Mt.prototype[U]=!0;var Dt=function(t){function e(t){this._iter=t,this.size=t.size}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.includes=function(t){return this._iter.includes(t)},e.prototype.__iterate=function(t,e){var r=this,n=0;return e&&_(this),this._iter.__iterate((function(i){return t(i,e?r.size-++n:n++,r)}),e)},e.prototype.__iterator=function(t,e){var r=this,n=this._iter.__iterator(1,e),i=0;return e&&_(this),new L((function(){var o=n.next();return o.done?o:W(t,e?r.size-++i:i++,o.value,o)}))},e}(Z),At=function(t){function e(t){this._iter=t,this.size=t.size}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.has=function(t){return this._iter.includes(t)},e.prototype.__iterate=function(t,e){var r=this;return this._iter.__iterate((function(e){return t(e,e,r)}),e)},e.prototype.__iterator=function(t,e){var r=this._iter.__iterator(1,e);return new L((function(){var e=r.next();return e.done?e:W(t,e.value,e.value,e)}))},e}(tt),qt=function(t){function e(t){this._iter=t,this.size=t.size}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.entrySeq=function(){return this._iter.toSeq()},e.prototype.__iterate=function(t,e){var r=this;return this._iter.__iterate((function(e){if(e){Nt(e);var n=S(e);return t(n?e.get(1):e[1],n?e.get(0):e[0],r)}}),e)},e.prototype.__iterator=function(t,e){var r=this._iter.__iterator(1,e);return new L((function(){for(;;){var e=r.next();if(e.done)return e;var n=e.value;if(n){Nt(n);var i=S(n);return W(t,i?n.get(0):n[0],i?n.get(1):n[1],e)}}}))},e}(X);function kt(t){var e=Jt(t);return e._iter=t,e.size=t.size,e.flip=function(){return t},e.reverse=function(){var e=t.reverse.apply(this);return e.flip=function(){return t.reverse()},e},e.has=function(e){return t.includes(e)},e.includes=function(e){return t.has(e)},e.cacheResult=Vt,e.__iterateUncached=function(e,r){var n=this;return t.__iterate((function(t,r){return!1!==e(r,t,n)}),r)},e.__iteratorUncached=function(e,r){if(2===e){var n=t.__iterator(e,r);return new L((function(){var t=n.next();if(!t.done){var e=t.value[0];t.value[0]=t.value[1],t.value[1]=e}return t}))}return t.__iterator(1===e?0:1,r)},e}function xt(t,e,r){var n=Jt(t);return n.size=t.size,n.has=function(e){return t.has(e)},n.get=function(n,i){var o=t.get(n,f);return o===f?i:e.call(r,o,n,t)},n.__iterateUncached=function(n,i){var o=this;return t.__iterate((function(t,i,u){return!1!==n(e.call(r,t,i,u),i,o)}),i)},n.__iteratorUncached=function(n,i){var o=t.__iterator(2,i);return new L((function(){var i=o.next();if(i.done)return i;var u=i.value,s=u[0];return W(n,s,e.call(r,u[1],s,t),i)}))},n}function Pt(t,e){var r=this,n=Jt(t);return n._iter=t,n.size=t.size,n.reverse=function(){return t},t.flip&&(n.flip=function(){var e=kt(t);return e.reverse=function(){return t.flip()},e}),n.get=function(r,n){return t.get(e?r:-1-r,n)},n.has=function(r){return t.has(e?r:-1-r)},n.includes=function(e){return t.includes(e)},n.cacheResult=Vt,n.__iterate=function(r,n){var i=this,o=0;return n&&_(t),t.__iterate((function(t,u){return r(t,e?u:n?i.size-++o:o++,i)}),!n)},n.__iterator=function(n,i){var o=0;i&&_(t);var u=t.__iterator(2,!i);return new L((function(){var t=u.next();if(t.done)return t;var s=t.value;return W(n,e?s[0]:i?r.size-++o:o++,s[1],t)}))},n}function Rt(t,e,r,n){var i=Jt(t);return n&&(i.has=function(n){var i=t.get(n,f);return i!==f&&!!e.call(r,i,n,t)},i.get=function(n,i){var o=t.get(n,f);return o!==f&&e.call(r,o,n,t)?o:i}),i.__iterateUncached=function(i,o){var u=this,s=0;return t.__iterate((function(t,o,a){if(e.call(r,t,o,a))return s++,i(t,n?o:s-1,u)}),o),s},i.__iteratorUncached=function(i,o){var u=t.__iterator(2,o),s=0;return new L((function(){for(;;){var o=u.next();if(o.done)return o;var a=o.value,c=a[0],f=a[1];if(e.call(r,f,c,t))return W(i,n?c:s++,f,o)}}))},i}function Ft(t,e,r,n){var i=t.size;if(y(e,r,i))return t;var o=d(e,i),u=g(r,i);if(o!=o||u!=u)return Ft(t.toSeq().cacheResult(),e,r,n);var s,a=u-o;a==a&&(s=a<0?0:a);var c=Jt(t);return c.size=0===s?s:t.size&&s||void 0,!n&&x(t)&&s>=0&&(c.get=function(e,r){return(e=l(this,e))>=0&&e<s?t.get(e+o,r):r}),c.__iterateUncached=function(e,r){var i=this;if(0===s)return 0;if(r)return this.cacheResult().__iterate(e,r);var u=0,a=!0,c=0;return t.__iterate((function(t,r){if(!a||!(a=u++<o))return c++,!1!==e(t,n?r:c-1,i)&&c!==s})),c},c.__iteratorUncached=function(e,r){if(0!==s&&r)return this.cacheResult().__iterator(e,r);if(0===s)return new L($);var i=t.__iterator(e,r),u=0,a=0;return new L((function(){for(;u++<o;)i.next();if(++a>s)return{value:void 0,done:!0};var t=i.next();return n||1===e||t.done?t:W(e,a-1,0===e?void 0:t.value[1],t)}))},c}function Ut(t,e,r,n){var i=Jt(t);return i.__iterateUncached=function(i,o){var u=this;if(o)return this.cacheResult().__iterate(i,o);var s=!0,a=0;return t.__iterate((function(t,o,c){if(!s||!(s=e.call(r,t,o,c)))return a++,i(t,n?o:a-1,u)})),a},i.__iteratorUncached=function(i,o){var u=this;if(o)return this.cacheResult().__iterator(i,o);var s=t.__iterator(2,o),a=!0,c=0;return new L((function(){var t,o,f;do{if((t=s.next()).done)return n||1===i?t:W(i,c++,0===i?void 0:t.value[1],t);var h=t.value;o=h[0],f=h[1],a&&(a=e.call(r,f,o,u))}while(a);return 2===i?t:W(i,o,f,t)}))},i}function Kt(t,e){var r=I(t),n=[t].concat(e).map((function(t){return S(t)?r&&(t=D(t)):t=r?ut(t):st(Array.isArray(t)?t:[t]),t})).filter((function(t){return 0!==t.size}));if(0===n.length)return t;if(1===n.length){var i=n[0];if(i===t||r&&I(i)||E(t)&&E(i))return i}var o=new et(n);return r?o=o.toKeyedSeq():E(t)||(o=o.toSetSeq()),(o=o.flatten(!0)).size=n.reduce((function(t,e){if(void 0!==t){var r=e.size;if(void 0!==r)return t+r}}),0),o}function Bt(t,e,r){var n=Jt(t);return n.__iterateUncached=function(i,o){if(o)return this.cacheResult().__iterate(i,o);var u=0,s=!1;return function t(a,c){a.__iterate((function(o,a){return(!e||c<e)&&S(o)?t(o,c+1):(u++,!1===i(o,r?a:u-1,n)&&(s=!0)),!s}),o)}(t,0),u},n.__iteratorUncached=function(n,i){if(i)return this.cacheResult().__iterator(n,i);var o=t.__iterator(n,i),u=[],s=0;return new L((function(){for(;o;){var t=o.next();if(!1===t.done){var a=t.value;if(2===n&&(a=a[1]),e&&!(u.length<e)||!S(a))return r?t:W(n,s++,a,t);u.push(o),o=a.__iterator(n,i)}else o=u.pop()}return{value:void 0,done:!0}}))},n}function Tt(t,e,r){e||(e=Gt);var n=I(t),i=0,o=t.toSeq().map((function(e,n){return[n,e,i++,r?r(e,n,t):e]})).valueSeq().toArray();return o.sort((function(t,r){return e(t[3],r[3])||t[2]-r[2]})).forEach(n?function(t,e){o[e].length=2}:function(t,e){o[e]=t[1]}),n?X(o):E(t)?Z(o):tt(o)}function Ct(t,e,r){if(e||(e=Gt),r){var n=t.toSeq().map((function(e,n){return[e,r(e,n,t)]})).reduce((function(t,r){return Lt(e,t[1],r[1])?r:t}));return n&&n[0]}return t.reduce((function(t,r){return Lt(e,t,r)?r:t}))}function Lt(t,e,r){var n=t(r,e);return 0===n&&r!==e&&(null==r||r!=r)||n>0}function Wt(t,e,r,n){var i=Jt(t),o=new et(r).map((function(t){return t.size}));return i.size=n?o.max():o.min(),i.__iterate=function(t,e){for(var r,n=this.__iterator(1,e),i=0;!(r=n.next()).done&&!1!==t(r.value,i++,this););return i},i.__iteratorUncached=function(t,i){var o=r.map((function(t){return t=M(t),J(i?t.reverse():t)})),u=0,s=!1;return new L((function(){var r;return s||(r=o.map((function(t){return t.next()})),s=n?r.every((function(t){return t.done})):r.some((function(t){return t.done}))),s?{value:void 0,done:!0}:W(t,u++,e.apply(null,r.map((function(t){return t.value}))))}))},i}function $t(t,e){return t===e?t:x(t)?e:t.constructor(e)}function Nt(t){if(t!==Object(t))throw new TypeError("Expected [K, V] tuple: "+t)}function Ht(t){return I(t)?D:E(t)?A:q}function Jt(t){return Object.create((I(t)?X:E(t)?Z:tt).prototype)}function Vt(){return this._iter.cacheResult?(this._iter.cacheResult(),this.size=this._iter.size,this):Q.prototype.cacheResult.call(this)}function Gt(t,e){return void 0===t&&void 0===e?0:void 0===t?1:void 0===e?-1:t>e?1:t<e?-1:0}function Yt(t,e){e=e||0;for(var r=Math.max(0,t.length-e),n=new Array(r),i=0;i<r;i++)n[i]=t[i+e];return n}function Qt(t,e){if(!t)throw new Error(e)}function Xt(t){Qt(t!==1/0,"Cannot perform this action with an infinite size.")}function Zt(t){if(Y(t)&&"string"!=typeof t)return t;if(K(t))return t.toArray();throw new TypeError("Invalid keyPath: expected Ordered Collection or Array: "+t)}function te(t){return t&&(t.constructor&&"Object"===t.constructor.name||void 0===t.constructor)}function ee(t){return"object"==typeof t&&(F(t)||Array.isArray(t)||te(t))}function re(t){try{return"string"==typeof t?JSON.stringify(t):String(t)}catch(e){return JSON.stringify(t)}}function ne(t,e){return F(t)?t.has(e):ee(t)&&G.call(t,e)}function ie(t,e,r){return F(t)?t.get(e,r):ne(t,e)?"function"==typeof t.get?t.get(e):t[e]:r}function oe(t){if(Array.isArray(t))return Yt(t);var e={};for(var r in t)G.call(t,r)&&(e[r]=t[r]);return e}function ue(t,e){if(!ee(t))throw new TypeError("Cannot update non-data-structure value: "+t);if(F(t)){if(!t.remove)throw new TypeError("Cannot update immutable value without .remove() method: "+t);return t.remove(e)}if(!G.call(t,e))return t;var r=oe(t);return Array.isArray(r)?r.splice(e,1):delete r[e],r}function se(t,e,r){if(!ee(t))throw new TypeError("Cannot update non-data-structure value: "+t);if(F(t)){if(!t.set)throw new TypeError("Cannot update immutable value without .set() method: "+t);return t.set(e,r)}if(G.call(t,e)&&r===t[e])return t;var n=oe(t);return n[e]=r,n}function ae(t,e,r,n){n||(n=r,r=void 0);var i=ce(F(t),t,Zt(e),0,r,n);return i===f?r:i}function ce(t,e,r,n,i,o){var u=e===f;if(n===r.length){var s=u?i:e,a=o(s);return a===s?e:a}if(!u&&!ee(e))throw new TypeError("Cannot update within non-data-structure value in path ["+r.slice(0,n).map(re)+"]: "+e);var c=r[n],h=u?f:ie(e,c,f),p=ce(h===f?t:F(h),h,r,n+1,i,o);return p===h?e:p===f?ue(e,c):se(u?t?Le():{}:e,c,p)}function fe(t,e,r){return ae(t,e,f,(function(){return r}))}function he(t,e){return fe(this,t,e)}function pe(t,e){return ae(t,e,(function(){return f}))}function _e(t){return pe(this,t)}function le(t,e,r,n){return ae(t,[e],r,n)}function ve(t,e,r){return 1===arguments.length?t(this):le(this,t,e,r)}function ye(t,e,r){return ae(this,t,e,r)}function de(){for(var t=[],e=arguments.length;e--;)t[e]=arguments[e];return we(this,t)}function ge(t){for(var e=[],r=arguments.length-1;r-- >0;)e[r]=arguments[r+1];if("function"!=typeof t)throw new TypeError("Invalid merger function: "+t);return we(this,e,t)}function we(t,e,r){for(var n=[],i=0;i<e.length;i++){var o=D(e[i]);0!==o.size&&n.push(o)}return 0===n.length?t:0!==t.toSeq().size||t.__ownerID||1!==n.length?t.withMutations((function(t){for(var e=r?function(e,n){le(t,n,f,(function(t){return t===f?e:r(t,e,n)}))}:function(e,r){t.set(r,e)},i=0;i<n.length;i++)n[i].forEach(e)})):t.constructor(n[0])}function me(t,e,r){return be(t,e,function(t){function e(r,n,i){return ee(r)&&ee(n)?be(r,[n],e):t?t(r,n,i):n}return e}(r))}function be(t,e,r){if(!ee(t))throw new TypeError("Cannot merge into non-data-structure value: "+t);if(F(t))return"function"==typeof r&&t.mergeWith?t.mergeWith.apply(t,[r].concat(e)):t.merge?t.merge.apply(t,e):t.concat.apply(t,e);for(var n=Array.isArray(t),i=t,o=n?A:D,u=n?function(e){i===t&&(i=oe(i)),i.push(e)}:function(e,n){var o=G.call(i,n),u=o&&r?r(i[n],e,n):e;o&&u===i[n]||(i===t&&(i=oe(i)),i[n]=u)},s=0;s<e.length;s++)o(e[s]).forEach(u);return i}function Se(){for(var t=[],e=arguments.length;e--;)t[e]=arguments[e];return me(this,t)}function ze(t){for(var e=[],r=arguments.length-1;r-- >0;)e[r]=arguments[r+1];return me(this,e,t)}function Ie(t){for(var e=[],r=arguments.length-1;r-- >0;)e[r]=arguments[r+1];return ae(this,t,Le(),(function(t){return be(t,e)}))}function Oe(t){for(var e=[],r=arguments.length-1;r-- >0;)e[r]=arguments[r+1];return ae(this,t,Le(),(function(t){return me(t,e)}))}function Ee(t){var e=this.asMutable();return t(e),e.wasAltered()?e.__ensureOwner(this.__ownerID):this}function je(){return this.__ownerID?this:this.__ensureOwner(new p)}function Me(){return this.__ensureOwner()}function De(){return this.__altered}Dt.prototype.cacheResult=Mt.prototype.cacheResult=At.prototype.cacheResult=qt.prototype.cacheResult=Vt;var Ae=function(t){function e(e){return null==e?Le():ft(e)&&!K(e)?e:Le().withMutations((function(r){var n=t(e);Xt(n.size),n.forEach((function(t,e){return r.set(e,t)}))}))}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.of=function(){for(var t=[],e=arguments.length;e--;)t[e]=arguments[e];return Le().withMutations((function(e){for(var r=0;r<t.length;r+=2){if(r+1>=t.length)throw new Error("Missing value for key: "+t[r]);e.set(t[r],t[r+1])}}))},e.prototype.toString=function(){return this.__toString("Map {","}")},e.prototype.get=function(t,e){return this._root?this._root.get(0,void 0,t,e):e},e.prototype.set=function(t,e){return We(this,t,e)},e.prototype.remove=function(t){return We(this,t,f)},e.prototype.deleteAll=function(t){var e=M(t);return 0===e.size?this:this.withMutations((function(t){e.forEach((function(e){return t.remove(e)}))}))},e.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=0,this._root=null,this.__hash=void 0,this.__altered=!0,this):Le()},e.prototype.sort=function(t){return lr(Tt(this,t))},e.prototype.sortBy=function(t,e){return lr(Tt(this,e,t))},e.prototype.map=function(t,e){return this.withMutations((function(r){r.forEach((function(n,i){r.set(i,t.call(e,n,i,r))}))}))},e.prototype.__iterator=function(t,e){return new Ke(this,t,e)},e.prototype.__iterate=function(t,e){var r=this,n=0;return this._root&&this._root.iterate((function(e){return n++,t(e[1],e[0],r)}),e),n},e.prototype.__ensureOwner=function(t){return t===this.__ownerID?this:t?Ce(this.size,this._root,t,this.__hash):0===this.size?Le():(this.__ownerID=t,this.__altered=!1,this)},e}(D);Ae.isMap=ft;var qe=Ae.prototype;qe[ct]=!0,qe.delete=qe.remove,qe.removeAll=qe.deleteAll,qe.setIn=he,qe.removeIn=qe.deleteIn=_e,qe.update=ve,qe.updateIn=ye,qe.merge=qe.concat=de,qe.mergeWith=ge,qe.mergeDeep=Se,qe.mergeDeepWith=ze,qe.mergeIn=Ie,qe.mergeDeepIn=Oe,qe.withMutations=Ee,qe.wasAltered=De,qe.asImmutable=Me,qe["@@transducer/init"]=qe.asMutable=je,qe["@@transducer/step"]=function(t,e){return t.set(e[0],e[1])},qe["@@transducer/result"]=function(t){return t.asImmutable()};var ke=function(t,e){this.ownerID=t,this.entries=e};ke.prototype.get=function(t,e,r,n){for(var i=this.entries,o=0,u=i.length;o<u;o++)if(_t(r,i[o][0]))return i[o][1];return n},ke.prototype.update=function(t,e,r,n,i,o,u){for(var s=i===f,a=this.entries,c=0,_=a.length;c<_&&!_t(n,a[c][0]);c++);var l=c<_;if(l?a[c][1]===i:s)return this;if(h(u),(s||!l)&&h(o),!s||1!==a.length){if(!l&&!s&&a.length>=Ge)return function(t,e,r,n){t||(t=new p);for(var i=new Fe(t,yt(r),[r,n]),o=0;o<e.length;o++){var u=e[o];i=i.update(t,0,void 0,u[0],u[1])}return i}(t,a,n,i);var v=t&&t===this.ownerID,y=v?a:Yt(a);return l?s?c===_-1?y.pop():y[c]=y.pop():y[c]=[n,i]:y.push([n,i]),v?(this.entries=y,this):new ke(t,y)}};var xe=function(t,e,r){this.ownerID=t,this.bitmap=e,this.nodes=r};xe.prototype.get=function(t,e,r,n){void 0===e&&(e=yt(r));var i=1<<((0===t?e:e>>>t)&c),o=this.bitmap;return 0==(o&i)?n:this.nodes[Je(o&i-1)].get(t+5,e,r,n)},xe.prototype.update=function(t,e,r,n,i,o,u){void 0===r&&(r=yt(n));var s=(0===e?r:r>>>e)&c,h=1<<s,p=this.bitmap,_=0!=(p&h);if(!_&&i===f)return this;var l=Je(p&h-1),v=this.nodes,y=_?v[l]:void 0,d=$e(y,t,e+5,r,n,i,o,u);if(d===y)return this;if(!_&&d&&v.length>=Ye)return function(t,e,r,n,i){for(var o=0,u=new Array(a),s=0;0!==r;s++,r>>>=1)u[s]=1&r?e[o++]:void 0;return u[n]=i,new Pe(t,o+1,u)}(t,v,p,s,d);if(_&&!d&&2===v.length&&Ne(v[1^l]))return v[1^l];if(_&&d&&1===v.length&&Ne(d))return d;var g=t&&t===this.ownerID,w=_?d?p:p^h:p|h,m=_?d?Ve(v,l,d,g):function(t,e,r){var n=t.length-1;if(r&&e===n)return t.pop(),t;for(var i=new Array(n),o=0,u=0;u<n;u++)u===e&&(o=1),i[u]=t[u+o];return i}(v,l,g):function(t,e,r,n){var i=t.length+1;if(n&&e+1===i)return t[e]=r,t;for(var o=new Array(i),u=0,s=0;s<i;s++)s===e?(o[s]=r,u=-1):o[s]=t[s+u];return o}(v,l,d,g);return g?(this.bitmap=w,this.nodes=m,this):new xe(t,w,m)};var Pe=function(t,e,r){this.ownerID=t,this.count=e,this.nodes=r};Pe.prototype.get=function(t,e,r,n){void 0===e&&(e=yt(r));var i=(0===t?e:e>>>t)&c,o=this.nodes[i];return o?o.get(t+5,e,r,n):n},Pe.prototype.update=function(t,e,r,n,i,o,u){void 0===r&&(r=yt(n));var s=(0===e?r:r>>>e)&c,a=i===f,h=this.nodes,p=h[s];if(a&&!p)return this;var _=$e(p,t,e+5,r,n,i,o,u);if(_===p)return this;var l=this.count;if(p){if(!_&&--l<Qe)return function(t,e,r,n){for(var i=0,o=0,u=new Array(r),s=0,a=1,c=e.length;s<c;s++,a<<=1){var f=e[s];void 0!==f&&s!==n&&(i|=a,u[o++]=f)}return new xe(t,i,u)}(t,h,l,s)}else l++;var v=t&&t===this.ownerID,y=Ve(h,s,_,v);return v?(this.count=l,this.nodes=y,this):new Pe(t,l,y)};var Re=function(t,e,r){this.ownerID=t,this.keyHash=e,this.entries=r};Re.prototype.get=function(t,e,r,n){for(var i=this.entries,o=0,u=i.length;o<u;o++)if(_t(r,i[o][0]))return i[o][1];return n},Re.prototype.update=function(t,e,r,n,i,o,u){void 0===r&&(r=yt(n));var s=i===f;if(r!==this.keyHash)return s?this:(h(u),h(o),He(this,t,e,r,[n,i]));for(var a=this.entries,c=0,p=a.length;c<p&&!_t(n,a[c][0]);c++);var _=c<p;if(_?a[c][1]===i:s)return this;if(h(u),(s||!_)&&h(o),s&&2===p)return new Fe(t,this.keyHash,a[1^c]);var l=t&&t===this.ownerID,v=l?a:Yt(a);return _?s?c===p-1?v.pop():v[c]=v.pop():v[c]=[n,i]:v.push([n,i]),l?(this.entries=v,this):new Re(t,this.keyHash,v)};var Fe=function(t,e,r){this.ownerID=t,this.keyHash=e,this.entry=r};Fe.prototype.get=function(t,e,r,n){return _t(r,this.entry[0])?this.entry[1]:n},Fe.prototype.update=function(t,e,r,n,i,o,u){var s=i===f,a=_t(n,this.entry[0]);return(a?i===this.entry[1]:s)?this:(h(u),s?void h(o):a?t&&t===this.ownerID?(this.entry[1]=i,this):new Fe(t,this.keyHash,[n,i]):(h(o),He(this,t,e,yt(n),[n,i])))},ke.prototype.iterate=Re.prototype.iterate=function(t,e){for(var r=this.entries,n=0,i=r.length-1;n<=i;n++)if(!1===t(r[e?i-n:n]))return!1},xe.prototype.iterate=Pe.prototype.iterate=function(t,e){for(var r=this.nodes,n=0,i=r.length-1;n<=i;n++){var o=r[e?i-n:n];if(o&&!1===o.iterate(t,e))return!1}},Fe.prototype.iterate=function(t,e){return t(this.entry)};var Ue,Ke=function(t){function e(t,e,r){this._type=e,this._reverse=r,this._stack=t._root&&Te(t._root)}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.next=function(){for(var t=this,e=this._type,r=this._stack;r;){var n=r.node,i=r.index++,o=void 0;if(n.entry){if(0===i)return Be(e,n.entry)}else if(n.entries){if(i<=(o=n.entries.length-1))return Be(e,n.entries[t._reverse?o-i:i])}else if(i<=(o=n.nodes.length-1)){var u=n.nodes[t._reverse?o-i:i];if(u){if(u.entry)return Be(e,u.entry);r=t._stack=Te(u,r)}continue}r=t._stack=t._stack.__prev}return{value:void 0,done:!0}},e}(L);function Be(t,e){return W(t,e[0],e[1])}function Te(t,e){return{node:t,index:0,__prev:e}}function Ce(t,e,r,n){var i=Object.create(qe);return i.size=t,i._root=e,i.__ownerID=r,i.__hash=n,i.__altered=!1,i}function Le(){return Ue||(Ue=Ce(0))}function We(t,e,r){var n,i;if(t._root){var o={value:!1},u={value:!1};if(n=$e(t._root,t.__ownerID,0,void 0,e,r,o,u),!u.value)return t;i=t.size+(o.value?r===f?-1:1:0)}else{if(r===f)return t;i=1,n=new ke(t.__ownerID,[[e,r]])}return t.__ownerID?(t.size=i,t._root=n,t.__hash=void 0,t.__altered=!0,t):n?Ce(i,n):Le()}function $e(t,e,r,n,i,o,u,s){return t?t.update(e,r,n,i,o,u,s):o===f?t:(h(s),h(u),new Fe(e,n,[i,o]))}function Ne(t){return t.constructor===Fe||t.constructor===Re}function He(t,e,r,n,i){if(t.keyHash===n)return new Re(e,n,[t.entry,i]);var o,u=(0===r?t.keyHash:t.keyHash>>>r)&c,s=(0===r?n:n>>>r)&c,a=u===s?[He(t,e,r+5,n,i)]:(o=new Fe(e,n,i),u<s?[t,o]:[o,t]);return new xe(e,1<<u|1<<s,a)}function Je(t){return t=(t=(858993459&(t-=t>>1&1431655765))+(t>>2&858993459))+(t>>4)&252645135,t+=t>>8,127&(t+=t>>16)}function Ve(t,e,r,n){var i=n?t:Yt(t);return i[e]=r,i}var Ge=8,Ye=16,Qe=8,Xe="@@__IMMUTABLE_LIST__@@";function Ze(t){return Boolean(t&&t[Xe])}var tr=function(t){function e(e){var r=sr();if(null==e)return r;if(Ze(e))return e;var n=t(e),i=n.size;return 0===i?r:(Xt(i),i>0&&i<a?ur(0,i,5,null,new rr(n.toArray())):r.withMutations((function(t){t.setSize(i),n.forEach((function(e,r){return t.set(r,e)}))})))}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.of=function(){return this(arguments)},e.prototype.toString=function(){return this.__toString("List [","]")},e.prototype.get=function(t,e){if((t=l(this,t))>=0&&t<this.size){var r=fr(this,t+=this._origin);return r&&r.array[t&c]}return e},e.prototype.set=function(t,e){return function(t,e,r){if((e=l(t,e))!=e)return t;if(e>=t.size||e<0)return t.withMutations((function(t){e<0?hr(t,e).set(0,r):hr(t,0,e+1).set(e,r)}));e+=t._origin;var n=t._tail,i=t._root,o={value:!1};e>=pr(t._capacity)?n=ar(n,t.__ownerID,0,e,r,o):i=ar(i,t.__ownerID,t._level,e,r,o);if(!o.value)return t;if(t.__ownerID)return t._root=i,t._tail=n,t.__hash=void 0,t.__altered=!0,t;return ur(t._origin,t._capacity,t._level,i,n)}(this,t,e)},e.prototype.remove=function(t){return this.has(t)?0===t?this.shift():t===this.size-1?this.pop():this.splice(t,1):this},e.prototype.insert=function(t,e){return this.splice(t,0,e)},e.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=this._origin=this._capacity=0,this._level=5,this._root=this._tail=null,this.__hash=void 0,this.__altered=!0,this):sr()},e.prototype.push=function(){var t=arguments,e=this.size;return this.withMutations((function(r){hr(r,0,e+t.length);for(var n=0;n<t.length;n++)r.set(e+n,t[n])}))},e.prototype.pop=function(){return hr(this,0,-1)},e.prototype.unshift=function(){var t=arguments;return this.withMutations((function(e){hr(e,-t.length);for(var r=0;r<t.length;r++)e.set(r,t[r])}))},e.prototype.shift=function(){return hr(this,1)},e.prototype.concat=function(){for(var e=arguments,r=[],n=0;n<arguments.length;n++){var i=e[n],o=t("string"!=typeof i&&N(i)?i:[i]);0!==o.size&&r.push(o)}return 0===r.length?this:0!==this.size||this.__ownerID||1!==r.length?this.withMutations((function(t){r.forEach((function(e){return e.forEach((function(e){return t.push(e)}))}))})):this.constructor(r[0])},e.prototype.setSize=function(t){return hr(this,0,t)},e.prototype.map=function(t,e){var r=this;return this.withMutations((function(n){for(var i=0;i<r.size;i++)n.set(i,t.call(e,n.get(i),i,n))}))},e.prototype.slice=function(t,e){var r=this.size;return y(t,e,r)?this:hr(this,d(t,r),g(e,r))},e.prototype.__iterator=function(t,e){var r=e?this.size:0,n=or(this,e);return new L((function(){var i=n();return i===ir?{value:void 0,done:!0}:W(t,e?--r:r++,i)}))},e.prototype.__iterate=function(t,e){for(var r,n=e?this.size:0,i=or(this,e);(r=i())!==ir&&!1!==t(r,e?--n:n++,this););return n},e.prototype.__ensureOwner=function(t){return t===this.__ownerID?this:t?ur(this._origin,this._capacity,this._level,this._root,this._tail,t,this.__hash):0===this.size?sr():(this.__ownerID=t,this.__altered=!1,this)},e}(A);tr.isList=Ze;var er=tr.prototype;er[Xe]=!0,er.delete=er.remove,er.merge=er.concat,er.setIn=he,er.deleteIn=er.removeIn=_e,er.update=ve,er.updateIn=ye,er.mergeIn=Ie,er.mergeDeepIn=Oe,er.withMutations=Ee,er.wasAltered=De,er.asImmutable=Me,er["@@transducer/init"]=er.asMutable=je,er["@@transducer/step"]=function(t,e){return t.push(e)},er["@@transducer/result"]=function(t){return t.asImmutable()};var rr=function(t,e){this.array=t,this.ownerID=e};rr.prototype.removeBefore=function(t,e,r){if(r===e?1<<e:0===this.array.length)return this;var n=r>>>e&c;if(n>=this.array.length)return new rr([],t);var i,o=0===n;if(e>0){var u=this.array[n];if((i=u&&u.removeBefore(t,e-5,r))===u&&o)return this}if(o&&!i)return this;var s=cr(this,t);if(!o)for(var a=0;a<n;a++)s.array[a]=void 0;return i&&(s.array[n]=i),s},rr.prototype.removeAfter=function(t,e,r){if(r===(e?1<<e:0)||0===this.array.length)return this;var n,i=r-1>>>e&c;if(i>=this.array.length)return this;if(e>0){var o=this.array[i];if((n=o&&o.removeAfter(t,e-5,r))===o&&i===this.array.length-1)return this}var u=cr(this,t);return u.array.splice(i+1),n&&(u.array[i]=n),u};var nr,ir={};function or(t,e){var r=t._origin,n=t._capacity,i=pr(n),o=t._tail;return u(t._root,t._level,0);function u(t,s,c){return 0===s?function(t,u){var s=u===i?o&&o.array:t&&t.array,c=u>r?0:r-u,f=n-u;f>a&&(f=a);return function(){if(c===f)return ir;var t=e?--f:c++;return s&&s[t]}}(t,c):function(t,i,o){var s,c=t&&t.array,f=o>r?0:r-o>>i,h=1+(n-o>>i);h>a&&(h=a);return function(){for(;;){if(s){var t=s();if(t!==ir)return t;s=null}if(f===h)return ir;var r=e?--h:f++;s=u(c&&c[r],i-5,o+(r<<i))}}}(t,s,c)}}function ur(t,e,r,n,i,o,u){var s=Object.create(er);return s.size=e-t,s._origin=t,s._capacity=e,s._level=r,s._root=n,s._tail=i,s.__ownerID=o,s.__hash=u,s.__altered=!1,s}function sr(){return nr||(nr=ur(0,0,5))}function ar(t,e,r,n,i,o){var u,s=n>>>r&c,a=t&&s<t.array.length;if(!a&&void 0===i)return t;if(r>0){var f=t&&t.array[s],p=ar(f,e,r-5,n,i,o);return p===f?t:((u=cr(t,e)).array[s]=p,u)}return a&&t.array[s]===i?t:(o&&h(o),u=cr(t,e),void 0===i&&s===u.array.length-1?u.array.pop():u.array[s]=i,u)}function cr(t,e){return e&&t&&e===t.ownerID?t:new rr(t?t.array.slice():[],e)}function fr(t,e){if(e>=pr(t._capacity))return t._tail;if(e<1<<t._level+5){for(var r=t._root,n=t._level;r&&n>0;)r=r.array[e>>>n&c],n-=5;return r}}function hr(t,e,r){void 0!==e&&(e|=0),void 0!==r&&(r|=0);var n=t.__ownerID||new p,i=t._origin,o=t._capacity,u=i+e,s=void 0===r?o:r<0?o+r:i+r;if(u===i&&s===o)return t;if(u>=s)return t.clear();for(var a=t._level,f=t._root,h=0;u+h<0;)f=new rr(f&&f.array.length?[void 0,f]:[],n),h+=1<<(a+=5);h&&(u+=h,i+=h,s+=h,o+=h);for(var _=pr(o),l=pr(s);l>=1<<a+5;)f=new rr(f&&f.array.length?[f]:[],n),a+=5;var v=t._tail,y=l<_?fr(t,s-1):l>_?new rr([],n):v;if(v&&l>_&&u<o&&v.array.length){for(var d=f=cr(f,n),g=a;g>5;g-=5){var w=_>>>g&c;d=d.array[w]=cr(d.array[w],n)}d.array[_>>>5&c]=v}if(s<o&&(y=y&&y.removeAfter(n,0,s)),u>=l)u-=l,s-=l,a=5,f=null,y=y&&y.removeBefore(n,0,u);else if(u>i||l<_){for(h=0;f;){var m=u>>>a&c;if(m!==l>>>a&c)break;m&&(h+=(1<<a)*m),a-=5,f=f.array[m]}f&&u>i&&(f=f.removeBefore(n,a,u-h)),f&&l<_&&(f=f.removeAfter(n,a,l-h)),h&&(u-=h,s-=h)}return t.__ownerID?(t.size=s-u,t._origin=u,t._capacity=s,t._level=a,t._root=f,t._tail=y,t.__hash=void 0,t.__altered=!0,t):ur(u,s,a,f,y)}function pr(t){return t<a?0:t-1>>>5<<5}var _r,lr=function(t){function e(t){return null==t?yr():ht(t)?t:yr().withMutations((function(e){var r=D(t);Xt(r.size),r.forEach((function(t,r){return e.set(r,t)}))}))}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.of=function(){return this(arguments)},e.prototype.toString=function(){return this.__toString("OrderedMap {","}")},e.prototype.get=function(t,e){var r=this._map.get(t);return void 0!==r?this._list.get(r)[1]:e},e.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=0,this._map.clear(),this._list.clear(),this):yr()},e.prototype.set=function(t,e){return dr(this,t,e)},e.prototype.remove=function(t){return dr(this,t,f)},e.prototype.wasAltered=function(){return this._map.wasAltered()||this._list.wasAltered()},e.prototype.__iterate=function(t,e){var r=this;return this._list.__iterate((function(e){return e&&t(e[1],e[0],r)}),e)},e.prototype.__iterator=function(t,e){return this._list.fromEntrySeq().__iterator(t,e)},e.prototype.__ensureOwner=function(t){if(t===this.__ownerID)return this;var e=this._map.__ensureOwner(t),r=this._list.__ensureOwner(t);return t?vr(e,r,t,this.__hash):0===this.size?yr():(this.__ownerID=t,this._map=e,this._list=r,this)},e}(Ae);function vr(t,e,r,n){var i=Object.create(lr.prototype);return i.size=t?t.size:0,i._map=t,i._list=e,i.__ownerID=r,i.__hash=n,i}function yr(){return _r||(_r=vr(Le(),sr()))}function dr(t,e,r){var n,i,o=t._map,u=t._list,s=o.get(e),c=void 0!==s;if(r===f){if(!c)return t;u.size>=a&&u.size>=2*o.size?(n=(i=u.filter((function(t,e){return void 0!==t&&s!==e}))).toKeyedSeq().map((function(t){return t[0]})).flip().toMap(),t.__ownerID&&(n.__ownerID=i.__ownerID=t.__ownerID)):(n=o.remove(e),i=s===u.size-1?u.pop():u.set(s,void 0))}else if(c){if(r===u.get(s)[1])return t;n=o,i=u.set(s,[e,r])}else n=o.set(e,u.size),i=u.set(u.size,[e,r]);return t.__ownerID?(t.size=n.size,t._map=n,t._list=i,t.__hash=void 0,t):vr(n,i)}lr.isOrderedMap=ht,lr.prototype[U]=!0,lr.prototype.delete=lr.prototype.remove;var gr="@@__IMMUTABLE_STACK__@@";function wr(t){return Boolean(t&&t[gr])}var mr=function(t){function e(t){return null==t?Ir():wr(t)?t:Ir().pushAll(t)}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.of=function(){return this(arguments)},e.prototype.toString=function(){return this.__toString("Stack [","]")},e.prototype.get=function(t,e){var r=this._head;for(t=l(this,t);r&&t--;)r=r.next;return r?r.value:e},e.prototype.peek=function(){return this._head&&this._head.value},e.prototype.push=function(){var t=arguments;if(0===arguments.length)return this;for(var e=this.size+arguments.length,r=this._head,n=arguments.length-1;n>=0;n--)r={value:t[n],next:r};return this.__ownerID?(this.size=e,this._head=r,this.__hash=void 0,this.__altered=!0,this):zr(e,r)},e.prototype.pushAll=function(e){if(0===(e=t(e)).size)return this;if(0===this.size&&wr(e))return e;Xt(e.size);var r=this.size,n=this._head;return e.__iterate((function(t){r++,n={value:t,next:n}}),!0),this.__ownerID?(this.size=r,this._head=n,this.__hash=void 0,this.__altered=!0,this):zr(r,n)},e.prototype.pop=function(){return this.slice(1)},e.prototype.clear=function(){return 0===this.size?this:this.__ownerID?(this.size=0,this._head=void 0,this.__hash=void 0,this.__altered=!0,this):Ir()},e.prototype.slice=function(e,r){if(y(e,r,this.size))return this;var n=d(e,this.size);if(g(r,this.size)!==this.size)return t.prototype.slice.call(this,e,r);for(var i=this.size-n,o=this._head;n--;)o=o.next;return this.__ownerID?(this.size=i,this._head=o,this.__hash=void 0,this.__altered=!0,this):zr(i,o)},e.prototype.__ensureOwner=function(t){return t===this.__ownerID?this:t?zr(this.size,this._head,t,this.__hash):0===this.size?Ir():(this.__ownerID=t,this.__altered=!1,this)},e.prototype.__iterate=function(t,e){var r=this;if(e)return new et(this.toArray()).__iterate((function(e,n){return t(e,n,r)}),e);for(var n=0,i=this._head;i&&!1!==t(i.value,n++,r);)i=i.next;return n},e.prototype.__iterator=function(t,e){if(e)return new et(this.toArray()).__iterator(t,e);var r=0,n=this._head;return new L((function(){if(n){var e=n.value;return n=n.next,W(t,r++,e)}return{value:void 0,done:!0}}))},e}(A);mr.isStack=wr;var br,Sr=mr.prototype;function zr(t,e,r,n){var i=Object.create(Sr);return i.size=t,i._head=e,i.__ownerID=r,i.__hash=n,i.__altered=!1,i}function Ir(){return br||(br=zr(0))}Sr[gr]=!0,Sr.shift=Sr.pop,Sr.unshift=Sr.push,Sr.unshiftAll=Sr.pushAll,Sr.withMutations=Ee,Sr.wasAltered=De,Sr.asImmutable=Me,Sr["@@transducer/init"]=Sr.asMutable=je,Sr["@@transducer/step"]=function(t,e){return t.unshift(e)},Sr["@@transducer/result"]=function(t){return t.asImmutable()};var Or="@@__IMMUTABLE_SET__@@";function Er(t){return Boolean(t&&t[Or])}function jr(t){return Er(t)&&K(t)}function Mr(t,e){if(t===e)return!0;if(!S(e)||void 0!==t.size&&void 0!==e.size&&t.size!==e.size||void 0!==t.__hash&&void 0!==e.__hash&&t.__hash!==e.__hash||I(t)!==I(e)||E(t)!==E(e)||K(t)!==K(e))return!1;if(0===t.size&&0===e.size)return!0;var r=!j(t);if(K(t)){var n=t.entries();return e.every((function(t,e){var i=n.next().value;return i&&_t(i[1],t)&&(r||_t(i[0],e))}))&&n.next().done}var i=!1;if(void 0===t.size)if(void 0===e.size)"function"==typeof t.cacheResult&&t.cacheResult();else{i=!0;var o=t;t=e,e=o}var u=!0,s=e.__iterate((function(e,n){if(r?!t.has(e):i?!_t(e,t.get(n,f)):!_t(t.get(n,f),e))return u=!1,!1}));return u&&t.size===s}function Dr(t,e){var r=function(r){t.prototype[r]=e[r]};return Object.keys(e).forEach(r),Object.getOwnPropertySymbols&&Object.getOwnPropertySymbols(e).forEach(r),t}function Ar(t){if(!t||"object"!=typeof t)return t;if(!S(t)){if(!ee(t))return t;t=Q(t)}if(I(t)){var e={};return t.__iterate((function(t,r){e[r]=Ar(t)})),e}var r=[];return t.__iterate((function(t){r.push(Ar(t))})),r}var qr=function(t){function e(e){return null==e?Fr():Er(e)&&!K(e)?e:Fr().withMutations((function(r){var n=t(e);Xt(n.size),n.forEach((function(t){return r.add(t)}))}))}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.of=function(){return this(arguments)},e.fromKeys=function(t){return this(D(t).keySeq())},e.intersect=function(t){return(t=M(t).toArray()).length?xr.intersect.apply(e(t.pop()),t):Fr()},e.union=function(t){return(t=M(t).toArray()).length?xr.union.apply(e(t.pop()),t):Fr()},e.prototype.toString=function(){return this.__toString("Set {","}")},e.prototype.has=function(t){return this._map.has(t)},e.prototype.add=function(t){return Pr(this,this._map.set(t,t))},e.prototype.remove=function(t){return Pr(this,this._map.remove(t))},e.prototype.clear=function(){return Pr(this,this._map.clear())},e.prototype.map=function(t,e){var r=this;return Pr(this,this._map.map((function(e){return t(e,e,r)}),e))},e.prototype.union=function(){for(var e=[],r=arguments.length;r--;)e[r]=arguments[r];return 0===(e=e.filter((function(t){return 0!==t.size}))).length?this:0!==this.size||this.__ownerID||1!==e.length?this.withMutations((function(r){for(var n=0;n<e.length;n++)t(e[n]).forEach((function(t){return r.add(t)}))})):this.constructor(e[0])},e.prototype.intersect=function(){for(var e=[],r=arguments.length;r--;)e[r]=arguments[r];if(0===e.length)return this;e=e.map((function(e){return t(e)}));var n=[];return this.forEach((function(t){e.every((function(e){return e.includes(t)}))||n.push(t)})),this.withMutations((function(t){n.forEach((function(e){t.remove(e)}))}))},e.prototype.subtract=function(){for(var e=[],r=arguments.length;r--;)e[r]=arguments[r];if(0===e.length)return this;e=e.map((function(e){return t(e)}));var n=[];return this.forEach((function(t){e.some((function(e){return e.includes(t)}))&&n.push(t)})),this.withMutations((function(t){n.forEach((function(e){t.remove(e)}))}))},e.prototype.sort=function(t){return tn(Tt(this,t))},e.prototype.sortBy=function(t,e){return tn(Tt(this,e,t))},e.prototype.wasAltered=function(){return this._map.wasAltered()},e.prototype.__iterate=function(t,e){var r=this;return this._map.__iterate((function(e){return t(e,e,r)}),e)},e.prototype.__iterator=function(t,e){return this._map.__iterator(t,e)},e.prototype.__ensureOwner=function(t){if(t===this.__ownerID)return this;var e=this._map.__ensureOwner(t);return t?this.__make(e,t):0===this.size?this.__empty():(this.__ownerID=t,this._map=e,this)},e}(q);qr.isSet=Er;var kr,xr=qr.prototype;function Pr(t,e){return t.__ownerID?(t.size=e.size,t._map=e,t):e===t._map?t:0===e.size?t.__empty():t.__make(e)}function Rr(t,e){var r=Object.create(xr);return r.size=t?t.size:0,r._map=t,r.__ownerID=e,r}function Fr(){return kr||(kr=Rr(Le()))}xr[Or]=!0,xr.delete=xr.remove,xr.merge=xr.concat=xr.union,xr.withMutations=Ee,xr.asImmutable=Me,xr["@@transducer/init"]=xr.asMutable=je,xr["@@transducer/step"]=function(t,e){return t.add(e)},xr["@@transducer/result"]=function(t){return t.asImmutable()},xr.__empty=Fr,xr.__make=Rr;var Ur,Kr=function(t){function e(t,r,n){if(!(this instanceof e))return new e(t,r,n);if(Qt(0!==n,"Cannot step a Range by 0"),t=t||0,void 0===r&&(r=1/0),n=void 0===n?1:Math.abs(n),r<t&&(n=-n),this._start=t,this._end=r,this._step=n,this.size=Math.max(0,Math.ceil((r-t)/n-1)+1),0===this.size){if(Ur)return Ur;Ur=this}}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.toString=function(){return 0===this.size?"Range []":"Range [ "+this._start+"..."+this._end+(1!==this._step?" by "+this._step:"")+" ]"},e.prototype.get=function(t,e){return this.has(t)?this._start+l(this,t)*this._step:e},e.prototype.includes=function(t){var e=(t-this._start)/this._step;return e>=0&&e<this.size&&e===Math.floor(e)},e.prototype.slice=function(t,r){return y(t,r,this.size)?this:(t=d(t,this.size),(r=g(r,this.size))<=t?new e(0,0):new e(this.get(t,this._end),this.get(r,this._end),this._step))},e.prototype.indexOf=function(t){var e=t-this._start;if(e%this._step==0){var r=e/this._step;if(r>=0&&r<this.size)return r}return-1},e.prototype.lastIndexOf=function(t){return this.indexOf(t)},e.prototype.__iterate=function(t,e){for(var r=this.size,n=this._step,i=e?this._start+(r-1)*n:this._start,o=0;o!==r&&!1!==t(i,e?r-++o:o++,this);)i+=e?-n:n;return o},e.prototype.__iterator=function(t,e){var r=this.size,n=this._step,i=e?this._start+(r-1)*n:this._start,o=0;return new L((function(){if(o===r)return{value:void 0,done:!0};var u=i;return i+=e?-n:n,W(t,e?r-++o:o++,u)}))},e.prototype.equals=function(t){return t instanceof e?this._start===t._start&&this._end===t._end&&this._step===t._step:Mr(this,t)},e}(Z);function Br(t,e,r){for(var n=Zt(e),i=0;i!==n.length;)if((t=ie(t,n[i++],f))===f)return r;return t}function Tr(t,e){return Br(this,t,e)}function Cr(t,e){return Br(t,e,f)!==f}function Lr(){Xt(this.size);var t={};return this.__iterate((function(e,r){t[r]=e})),t}M.isIterable=S,M.isKeyed=I,M.isIndexed=E,M.isAssociative=j,M.isOrdered=K,M.Iterator=L,Dr(M,{toArray:function(){Xt(this.size);var t=new Array(this.size||0),e=I(this),r=0;return this.__iterate((function(n,i){t[r++]=e?[i,n]:n})),t},toIndexedSeq:function(){return new Dt(this)},toJS:function(){return Ar(this)},toKeyedSeq:function(){return new Mt(this,!0)},toMap:function(){return Ae(this.toKeyedSeq())},toObject:Lr,toOrderedMap:function(){return lr(this.toKeyedSeq())},toOrderedSet:function(){return tn(I(this)?this.valueSeq():this)},toSet:function(){return qr(I(this)?this.valueSeq():this)},toSetSeq:function(){return new At(this)},toSeq:function(){return E(this)?this.toIndexedSeq():I(this)?this.toKeyedSeq():this.toSetSeq()},toStack:function(){return mr(I(this)?this.valueSeq():this)},toList:function(){return tr(I(this)?this.valueSeq():this)},toString:function(){return"[Collection]"},__toString:function(t,e){return 0===this.size?t+e:t+" "+this.toSeq().map(this.__toStringMapper).join(", ")+" "+e},concat:function(){for(var t=[],e=arguments.length;e--;)t[e]=arguments[e];return $t(this,Kt(this,t))},includes:function(t){return this.some((function(e){return _t(e,t)}))},entries:function(){return this.__iterator(2)},every:function(t,e){Xt(this.size);var r=!0;return this.__iterate((function(n,i,o){if(!t.call(e,n,i,o))return r=!1,!1})),r},filter:function(t,e){return $t(this,Rt(this,t,e,!0))},find:function(t,e,r){var n=this.findEntry(t,e);return n?n[1]:r},forEach:function(t,e){return Xt(this.size),this.__iterate(e?t.bind(e):t)},join:function(t){Xt(this.size),t=void 0!==t?""+t:",";var e="",r=!0;return this.__iterate((function(n){r?r=!1:e+=t,e+=null!=n?n.toString():""})),e},keys:function(){return this.__iterator(0)},map:function(t,e){return $t(this,xt(this,t,e))},reduce:function(t,e,r){return Hr(this,t,e,r,arguments.length<2,!1)},reduceRight:function(t,e,r){return Hr(this,t,e,r,arguments.length<2,!0)},reverse:function(){return $t(this,Pt(this,!0))},slice:function(t,e){return $t(this,Ft(this,t,e,!0))},some:function(t,e){return!this.every(Gr(t),e)},sort:function(t){return $t(this,Tt(this,t))},values:function(){return this.__iterator(1)},butLast:function(){return this.slice(0,-1)},isEmpty:function(){return void 0!==this.size?0===this.size:!this.some((function(){return!0}))},count:function(t,e){return _(t?this.toSeq().filter(t,e):this)},countBy:function(t,e){return function(t,e,r){var n=Ae().asMutable();return t.__iterate((function(i,o){n.update(e.call(r,i,o,t),0,(function(t){return t+1}))})),n.asImmutable()}(this,t,e)},equals:function(t){return Mr(this,t)},entrySeq:function(){var t=this;if(t._cache)return new et(t._cache);var e=t.toSeq().map(Vr).toIndexedSeq();return e.fromEntrySeq=function(){return t.toSeq()},e},filterNot:function(t,e){return this.filter(Gr(t),e)},findEntry:function(t,e,r){var n=r;return this.__iterate((function(r,i,o){if(t.call(e,r,i,o))return n=[i,r],!1})),n},findKey:function(t,e){var r=this.findEntry(t,e);return r&&r[0]},findLast:function(t,e,r){return this.toKeyedSeq().reverse().find(t,e,r)},findLastEntry:function(t,e,r){return this.toKeyedSeq().reverse().findEntry(t,e,r)},findLastKey:function(t,e){return this.toKeyedSeq().reverse().findKey(t,e)},first:function(t){return this.find(v,null,t)},flatMap:function(t,e){return $t(this,function(t,e,r){var n=Ht(t);return t.toSeq().map((function(i,o){return n(e.call(r,i,o,t))})).flatten(!0)}(this,t,e))},flatten:function(t){return $t(this,Bt(this,t,!0))},fromEntrySeq:function(){return new qt(this)},get:function(t,e){return this.find((function(e,r){return _t(r,t)}),void 0,e)},getIn:Tr,groupBy:function(t,e){return function(t,e,r){var n=I(t),i=(K(t)?lr():Ae()).asMutable();t.__iterate((function(o,u){i.update(e.call(r,o,u,t),(function(t){return(t=t||[]).push(n?[u,o]:o),t}))}));var o=Ht(t);return i.map((function(e){return $t(t,o(e))})).asImmutable()}(this,t,e)},has:function(t){return this.get(t,f)!==f},hasIn:function(t){return Cr(this,t)},isSubset:function(t){return t="function"==typeof t.includes?t:M(t),this.every((function(e){return t.includes(e)}))},isSuperset:function(t){return(t="function"==typeof t.isSubset?t:M(t)).isSubset(this)},keyOf:function(t){return this.findKey((function(e){return _t(e,t)}))},keySeq:function(){return this.toSeq().map(Jr).toIndexedSeq()},last:function(t){return this.toSeq().reverse().first(t)},lastKeyOf:function(t){return this.toKeyedSeq().reverse().keyOf(t)},max:function(t){return Ct(this,t)},maxBy:function(t,e){return Ct(this,e,t)},min:function(t){return Ct(this,t?Yr(t):Xr)},minBy:function(t,e){return Ct(this,e?Yr(e):Xr,t)},rest:function(){return this.slice(1)},skip:function(t){return 0===t?this:this.slice(Math.max(0,t))},skipLast:function(t){return 0===t?this:this.slice(0,-Math.max(0,t))},skipWhile:function(t,e){return $t(this,Ut(this,t,e,!0))},skipUntil:function(t,e){return this.skipWhile(Gr(t),e)},sortBy:function(t,e){return $t(this,Tt(this,e,t))},take:function(t){return this.slice(0,Math.max(0,t))},takeLast:function(t){return this.slice(-Math.max(0,t))},takeWhile:function(t,e){return $t(this,function(t,e,r){var n=Jt(t);return n.__iterateUncached=function(n,i){var o=this;if(i)return this.cacheResult().__iterate(n,i);var u=0;return t.__iterate((function(t,i,s){return e.call(r,t,i,s)&&++u&&n(t,i,o)})),u},n.__iteratorUncached=function(n,i){var o=this;if(i)return this.cacheResult().__iterator(n,i);var u=t.__iterator(2,i),s=!0;return new L((function(){if(!s)return{value:void 0,done:!0};var t=u.next();if(t.done)return t;var i=t.value,a=i[0],c=i[1];return e.call(r,c,a,o)?2===n?t:W(n,a,c,t):(s=!1,{value:void 0,done:!0})}))},n}(this,t,e))},takeUntil:function(t,e){return this.takeWhile(Gr(t),e)},update:function(t){return t(this)},valueSeq:function(){return this.toIndexedSeq()},hashCode:function(){return this.__hash||(this.__hash=function(t){if(t.size===1/0)return 0;var e=K(t),r=I(t),n=e?1:0;return function(t,e){return e=lt(e,3432918353),e=lt(e<<15|e>>>-15,461845907),e=lt(e<<13|e>>>-13,5),e=lt((e=(e+3864292196|0)^t)^e>>>16,2246822507),e=vt((e=lt(e^e>>>13,3266489909))^e>>>16)}(t.__iterate(r?e?function(t,e){n=31*n+Zr(yt(t),yt(e))|0}:function(t,e){n=n+Zr(yt(t),yt(e))|0}:e?function(t){n=31*n+yt(t)|0}:function(t){n=n+yt(t)|0}),n)}(this))}});var Wr=M.prototype;Wr[b]=!0,Wr[C]=Wr.values,Wr.toJSON=Wr.toArray,Wr.__toStringMapper=re,Wr.inspect=Wr.toSource=function(){return this.toString()},Wr.chain=Wr.flatMap,Wr.contains=Wr.includes,Dr(D,{flip:function(){return $t(this,kt(this))},mapEntries:function(t,e){var r=this,n=0;return $t(this,this.toSeq().map((function(i,o){return t.call(e,[o,i],n++,r)})).fromEntrySeq())},mapKeys:function(t,e){var r=this;return $t(this,this.toSeq().flip().map((function(n,i){return t.call(e,n,i,r)})).flip())}});var $r=D.prototype;$r[z]=!0,$r[C]=Wr.entries,$r.toJSON=Lr,$r.__toStringMapper=function(t,e){return re(e)+": "+re(t)},Dr(A,{toKeyedSeq:function(){return new Mt(this,!1)},filter:function(t,e){return $t(this,Rt(this,t,e,!1))},findIndex:function(t,e){var r=this.findEntry(t,e);return r?r[0]:-1},indexOf:function(t){var e=this.keyOf(t);return void 0===e?-1:e},lastIndexOf:function(t){var e=this.lastKeyOf(t);return void 0===e?-1:e},reverse:function(){return $t(this,Pt(this,!1))},slice:function(t,e){return $t(this,Ft(this,t,e,!1))},splice:function(t,e){var r=arguments.length;if(e=Math.max(e||0,0),0===r||2===r&&!e)return this;t=d(t,t<0?this.count():this.size);var n=this.slice(0,t);return $t(this,1===r?n:n.concat(Yt(arguments,2),this.slice(t+e)))},findLastIndex:function(t,e){var r=this.findLastEntry(t,e);return r?r[0]:-1},first:function(t){return this.get(0,t)},flatten:function(t){return $t(this,Bt(this,t,!1))},get:function(t,e){return(t=l(this,t))<0||this.size===1/0||void 0!==this.size&&t>this.size?e:this.find((function(e,r){return r===t}),void 0,e)},has:function(t){return(t=l(this,t))>=0&&(void 0!==this.size?this.size===1/0||t<this.size:-1!==this.indexOf(t))},interpose:function(t){return $t(this,function(t,e){var r=Jt(t);return r.size=t.size&&2*t.size-1,r.__iterateUncached=function(r,n){var i=this,o=0;return t.__iterate((function(t){return(!o||!1!==r(e,o++,i))&&!1!==r(t,o++,i)}),n),o},r.__iteratorUncached=function(r,n){var i,o=t.__iterator(1,n),u=0;return new L((function(){return(!i||u%2)&&(i=o.next()).done?i:u%2?W(r,u++,e):W(r,u++,i.value,i)}))},r}(this,t))},interleave:function(){var t=[this].concat(Yt(arguments)),e=Wt(this.toSeq(),Z.of,t),r=e.flatten(!0);return e.size&&(r.size=e.size*t.length),$t(this,r)},keySeq:function(){return Kr(0,this.size)},last:function(t){return this.get(-1,t)},skipWhile:function(t,e){return $t(this,Ut(this,t,e,!1))},zip:function(){var t=[this].concat(Yt(arguments));return $t(this,Wt(this,Qr,t))},zipAll:function(){var t=[this].concat(Yt(arguments));return $t(this,Wt(this,Qr,t,!0))},zipWith:function(t){var e=Yt(arguments);return e[0]=this,$t(this,Wt(this,t,e))}});var Nr=A.prototype;function Hr(t,e,r,n,i,o){return Xt(t.size),t.__iterate((function(t,o,u){i?(i=!1,r=t):r=e.call(n,r,t,o,u)}),o),r}function Jr(t,e){return e}function Vr(t,e){return[e,t]}function Gr(t){return function(){return!t.apply(this,arguments)}}function Yr(t){return function(){return-t.apply(this,arguments)}}function Qr(){return Yt(arguments)}function Xr(t,e){return t<e?1:t>e?-1:0}function Zr(t,e){return t^e+2654435769+(t<<6)+(t>>2)|0}Nr[O]=!0,Nr[U]=!0,Dr(q,{get:function(t,e){return this.has(t)?t:e},includes:function(t){return this.has(t)},keySeq:function(){return this.valueSeq()}}),q.prototype.has=Wr.includes,q.prototype.contains=q.prototype.includes,Dr(X,D.prototype),Dr(Z,A.prototype),Dr(tt,q.prototype);var tn=function(t){function e(t){return null==t?on():jr(t)?t:on().withMutations((function(e){var r=q(t);Xt(r.size),r.forEach((function(t){return e.add(t)}))}))}return t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.of=function(){return this(arguments)},e.fromKeys=function(t){return this(D(t).keySeq())},e.prototype.toString=function(){return this.__toString("OrderedSet {","}")},e}(qr);tn.isOrderedSet=jr;var en,rn=tn.prototype;function nn(t,e){var r=Object.create(rn);return r.size=t?t.size:0,r._map=t,r.__ownerID=e,r}function on(){return en||(en=nn(yr()))}rn[U]=!0,rn.zip=Nr.zip,rn.zipWith=Nr.zipWith,rn.__empty=on,rn.__make=nn;var un=function(t,e){var r,n=function(o){var u=this;if(o instanceof n)return o;if(!(this instanceof n))return new n(o);if(!r){r=!0;var s=Object.keys(t),a=i._indices={};i._name=e,i._keys=s,i._defaultValues=t;for(var c=0;c<s.length;c++){var f=s[c];a[f]=c,i[f]?"object"==typeof console&&console.warn&&console.warn("Cannot define "+cn(u)+' with property "'+f+'" since that property name is part of the Record API.'):hn(i,f)}}this.__ownerID=void 0,this._values=tr().withMutations((function(t){t.setSize(u._keys.length),D(o).forEach((function(e,r){t.set(u._indices[r],e===u._defaultValues[r]?void 0:e)}))}))},i=n.prototype=Object.create(sn);return i.constructor=n,n};un.prototype.toString=function(){for(var t,e=cn(this)+" { ",r=this._keys,n=0,i=r.length;n!==i;n++)e+=(n?", ":"")+(t=r[n])+": "+re(this.get(t));return e+" }"},un.prototype.equals=function(t){return this===t||t&&this._keys===t._keys&&fn(this).equals(fn(t))},un.prototype.hashCode=function(){return fn(this).hashCode()},un.prototype.has=function(t){return this._indices.hasOwnProperty(t)},un.prototype.get=function(t,e){if(!this.has(t))return e;var r=this._indices[t],n=this._values.get(r);return void 0===n?this._defaultValues[t]:n},un.prototype.set=function(t,e){if(this.has(t)){var r=this._values.set(this._indices[t],e===this._defaultValues[t]?void 0:e);if(r!==this._values&&!this.__ownerID)return an(this,r)}return this},un.prototype.remove=function(t){return this.set(t)},un.prototype.clear=function(){var t=this._values.clear().setSize(this._keys.length);return this.__ownerID?this:an(this,t)},un.prototype.wasAltered=function(){return this._values.wasAltered()},un.prototype.toSeq=function(){return fn(this)},un.prototype.toJS=function(){return Ar(this)},un.prototype.entries=function(){return this.__iterator(2)},un.prototype.__iterator=function(t,e){return fn(this).__iterator(t,e)},un.prototype.__iterate=function(t,e){return fn(this).__iterate(t,e)},un.prototype.__ensureOwner=function(t){if(t===this.__ownerID)return this;var e=this._values.__ensureOwner(t);return t?an(this,e,t):(this.__ownerID=t,this._values=e,this)},un.isRecord=R,un.getDescriptiveName=cn;var sn=un.prototype;function an(t,e,r){var n=Object.create(Object.getPrototypeOf(t));return n._values=e,n.__ownerID=r,n}function cn(t){return t._name||t.constructor.name||"Record"}function fn(t){return ut(t._keys.map((function(e){return[e,t.get(e)]})))}function hn(t,e){try{Object.defineProperty(t,e,{get:function(){return this.get(e)},set:function(t){Qt(this.__ownerID,"Cannot set on an immutable record."),this.set(e,t)}})}catch(t){}}sn[P]=!0,sn.delete=sn.remove,sn.deleteIn=sn.removeIn=_e,sn.getIn=Tr,sn.hasIn=Wr.hasIn,sn.merge=de,sn.mergeWith=ge,sn.mergeIn=Ie,sn.mergeDeep=Se,sn.mergeDeepWith=ze,sn.mergeDeepIn=Oe,sn.setIn=he,sn.update=ve,sn.updateIn=ye,sn.withMutations=Ee,sn.asMutable=je,sn.asImmutable=Me,sn[C]=sn.entries,sn.toJSON=sn.toObject=Wr.toObject,sn.inspect=sn.toSource=function(){return this.toString()};var pn;!function(t){function e(t,r){if(!(this instanceof e))return new e(t,r);if(this._value=t,this.size=void 0===r?1/0:Math.max(0,r),0===this.size){if(pn)return pn;pn=this}}t&&(e.__proto__=t),e.prototype=Object.create(t&&t.prototype),e.prototype.constructor=e,e.prototype.toString=function(){return 0===this.size?"Repeat []":"Repeat [ "+this._value+" "+this.size+" times ]"},e.prototype.get=function(t,e){return this.has(t)?this._value:e},e.prototype.includes=function(t){return _t(this._value,t)},e.prototype.slice=function(t,r){var n=this.size;return y(t,r,n)?this:new e(this._value,g(r,n)-d(t,n))},e.prototype.reverse=function(){return this},e.prototype.indexOf=function(t){return _t(this._value,t)?0:-1},e.prototype.lastIndexOf=function(t){return _t(this._value,t)?this.size:-1},e.prototype.__iterate=function(t,e){for(var r=this.size,n=0;n!==r&&!1!==t(this._value,e?r-++n:n++,this););return n},e.prototype.__iterator=function(t,e){var r=this,n=this.size,i=0;return new L((function(){return i===n?{value:void 0,done:!0}:W(t,e?n-++i:i++,r._value)}))},e.prototype.equals=function(t){return t instanceof e?_t(this._value,t._value):Mr(t)}}(Z);let _n=function(t){return t[t.pdf_a_1a=0]="pdf_a_1a",t[t.pdf_a_1b=1]="pdf_a_1b",t[t.pdf_a_2a=2]="pdf_a_2a",t[t.pdf_a_2u=3]="pdf_a_2u",t[t.pdf_a_2b=4]="pdf_a_2b",t[t.pdf_a_3a=5]="pdf_a_3a",t[t.pdf_a_3u=6]="pdf_a_3u",t[t.pdf_a_3b=7]="pdf_a_3b",t[t.pdf_a_4=8]="pdf_a_4",t[t.pdf_a_4e=9]="pdf_a_4e",t[t.pdf_a_4f=10]="pdf_a_4f",t}({});function ln(t,e){var r=Object.keys(t);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(t);e&&(n=n.filter((function(e){return Object.getOwnPropertyDescriptor(t,e).enumerable}))),r.push.apply(r,n)}return r}function vn(t){for(var e=1;e<arguments.length;e++){var r=null!=arguments[e]?arguments[e]:{};e%2?ln(Object(r),!0).forEach((function(e){s(t,e,r[e])})):Object.getOwnPropertyDescriptors?Object.defineProperties(t,Object.getOwnPropertyDescriptors(r)):ln(Object(r)).forEach((function(e){Object.defineProperty(t,e,Object.getOwnPropertyDescriptor(r,e))}))}return t}const yn="/create.pdf",dn="/save.pdf",gn="/create.docx",wn="/save.docx",mn="/templateData.json",bn="undefined"!=typeof WorkerGlobalScope&&self instanceof WorkerGlobalScope;let Sn=null,zn=null;function In(t){let e;i(zn,"GdPicture WebAssembly is not loaded.");for(var r=arguments.length,n=new Array(r>1?r-1:0),o=1;o<r;o++)n[o-1]=arguments[o];for(const t of n)e=Object.assign(n[0],t);const u=JSON.stringify(vn({type:t},e)),s=JSON.parse(zn.CommandHandler(u));if(!s.success)throw new Error(s.errorReason+": "+s.errorMessage+"\n"+s.error);return s}const On=new class{_mountCustomFonts(t,e){i(Sn,"WebAssembly module not loaded."),Sn.FS.mkdir(e);{const r=bn?Sn.FS.filesystems.WORKERFS:Sn.FS.filesystems.MEMFS;Sn.FS.mount(r,{blobs:t},e)}}async loadModule(t,e,r,i,o,u,s){const{Assemblies:a,Module:c}=await async function(t,e){if("string"==typeof t){const r="pspdfkit-lib/",n=`${r}gdpicture-64fd9c8e/jit`,i=`${r}gdpicture-64fd9c8e/aot`;let o,u;e?(o=`${t}${i}/initDotnet.js`,u=`${t}${i}`):(o=`${t}${n}/initDotnet.js`,u=`${t}${n}`);const{initDotnet:s}=await import(o);return s(u)}throw new Error("GdPicture WASM loader not implemented")}(t,e);zn=a.GdPictureWasm.API,Sn=c,In("gdpicture/setLicense",{origin:r},{licenseKey:i||"DEMO_PSPDFKIT_WEB"});const f=o?"/fonts":"";if(o&&!Sn.FS.analyzePath(f).exists&&(this._mountCustomFonts(o,f),In("gdpicture/setFonts",{fontPaths:[f]})),u){const t=await async function(t){try{const e=await fetch(t).catch((e=>{throw new n(`Error fetching dynamic fonts file ${t}. ${e}`)}));if(200!==e.status)throw new n(`Error fetching dynamic fonts file ${t}. Status code: ${e.status}`);const r=await e.json().catch((e=>{throw new n(`Error parsing dynamic fonts file ${t}. ${e}`)}));return r}catch(t){throw t}}(u);In("gdpicture/setDynamicFontLoading",{baseUrl:u.split("/").slice(0,-1).join("/"),allowedFonts:t.availableFonts,v:1})}s&&In("gdpicture/setFontSubstitutions",{fontSubstitutions:s})}toPdf(t,e){Sn.FS.writeFile(yn,new Uint8Array(t));const r={file:dn,format:"pdf"};e&&e in _n&&(r.conformance=e);try{return In("gdpicture/process",{input:{file:yn},output:r}),Sn.FS.readFile(dn).buffer}finally{try{Sn.FS.unlink(dn)}catch(t){}}}toOffice(t,e){Sn.FS.writeFile(yn,new Uint8Array(t));const r=`/save.${e}`;try{return In("gdpicture/process",{input:{file:yn},output:{file:r,format:e}}),Sn.FS.readFile(r).buffer}finally{try{Sn.FS.unlink(r)}catch(t){console.log(t.message)}}}async populateDocumentTemplate(t,e){let r;Sn.FS.writeFile(gn,new Uint8Array(t));try{r=JSON.stringify(e,null,2)}catch(t){throw new Error("Invalid config data")}Sn.FS.writeFile(mn,r);try{return In("gdpicture/process-office-template",{inputFile:gn,modelAndConfigFile:mn,outputFile:wn}),Sn.FS.readFile(wn).buffer}finally{try{Sn.FS.unlink(wn),Sn.FS.unlink(mn)}catch(t){console.log(t.message)}}}},En=self;return En.global=En,En.module={},En.onmessage=async t=>{let e,r,{data:n}=t;try{const t=await On[n.action](...n.args);if(e={id:n.id,result:t},Array.isArray(t)){const e=t.filter((t=>t instanceof ArrayBuffer));e.length>0&&(r=e)}t instanceof ArrayBuffer&&(r=[t])}catch(t){const i=[...n.args].filter((t=>t instanceof ArrayBuffer));i.length>0&&(r=i),e={id:n.id,error:t.message||t.toString(),callArgs:n.args}}En.postMessage(e,r)},e})()));